-- Semi Tip

local SemiValidAnchorPos = {
"TOP",
"BOTTOM",
"LEFT",
"RIGHT",
"CENTER",
"TOPLEFT",
"TOPRIGHT",
"BOTTOMLEFT",
"BOTTOMRIGHT"
};



--functions
function Semi_Tip_Frame_OnLoad(self)
	-- set defaults for our variables in case of no saved variables
	if (SemiTipAnchorPos == nil) then
		SemiTipAnchorPos = "BOTTOMRIGHT";
	end
	if (SemiTipX == nil) then
		SemiTipX = -200;
	end
	if (SemiTipY == nil) then
		SemiTipY = 200;
	end
	--create the panel info
	panel = Semi_Tip_Frame;
	panel.name = "Semi Tooltip";
	if (IsAddOnLoaded("Semi_Core")) then
		panel.parent = "Semi";
	end
	_G[self:GetName().."Title"]:SetText("Semi Tooltip");
	_G[self:GetName().."Info"]:SetText("|cffffffffEnter X, Y, and an Anchor Position to move GameToolTip");
	_G[self:GetName().."_EditBox_X"]:SetAutoFocus(false);
	_G[self:GetName().."_EditBox_X"]:SetText(SemiTipX);
	_G[self:GetName().."_EditBox_X"]:SetCursorPosition(0);
	_G[self:GetName().."_EditBox_Y"]:SetAutoFocus(false);
	_G[self:GetName().."_EditBox_Y"]:SetText(SemiTipY);
	_G[self:GetName().."_EditBox_Y"]:SetCursorPosition(0);
	_G[self:GetName().."_EditBox_AnchorPos"]:SetAutoFocus(false);
	_G[self:GetName().."_EditBox_AnchorPos"]:SetText(SemiTipAnchorPos);
	_G[self:GetName().."_EditBox_AnchorPos"]:SetCursorPosition(0);
	InterfaceOptions_AddCategory(panel);
local Semi_Tip_X_Title = Semi_Tip_Frame:CreateFontString(nil, "ARTWORK", "GameFontNormal")
Semi_Tip_X_Title:SetPoint("TOPLEFT", Semi_Tip_Frame, "TOPLEFT", 20, -112);
Semi_Tip_X_Title:SetText("X");

local Semi_Tip_Y_Title = Semi_Tip_Frame:CreateFontString(nil, "ARTWORK", "GameFontNormal")
Semi_Tip_Y_Title:SetPoint("TOPLEFT", Semi_Tip_Frame, "TOPLEFT", 20, -152);
Semi_Tip_Y_Title:SetText("Y");

local Semi_Tip_AnchorPos_Title = Semi_Tip_Frame:CreateFontString(nil, "ARTWORK", "GameFontNormal")
Semi_Tip_AnchorPos_Title:SetPoint("TOPLEFT", Semi_Tip_Frame, "TOPLEFT", 20, -192);
Semi_Tip_AnchorPos_Title:SetText("-");
end

function Semi_Tip_Frame_OnShow(self)
	--
	_G[self:GetName().."_EditBox_X"]:SetText(SemiTipX);
	_G[self:GetName().."_EditBox_Y"]:SetText(SemiTipY);
	_G[self:GetName().."_EditBox_AnchorPos"]:SetText(SemiTipAnchorPos);
end

function Semi_Tip_EditBox_X_Action(self)
	--
	local text = self:GetText();
	text = strtrim(text);
	if (text == "") or (text == " ") or (text ~= tostring(tonumber(text))) then
		self:ClearFocus();
			return;
		end
	SemiTipX = text;
	self:ClearFocus();
end

function Semi_Tip_EditBox_Y_Action(self)
	--
	local text = self:GetText();
	text = strtrim(text);
	if (text == "") or (text == " ") or (text ~= tostring(tonumber(text))) then
		self:ClearFocus();
			return;
		end
	SemiTipY = text;
	self:ClearFocus();
end

function Semi_Tip_EditBox_AnchorPos_Action(self)
	local text = self:GetText();
	text = strtrim(text);
	if (text == "") or (text == " ") then
		self:ClearFocus();
			return;
		end
	text = strupper(text);
	for i=1, 9 do
		if text == SemiValidAnchorPos[i] then
			SemiTipAnchorPos = text;
		end
	end
	self:ClearFocus();
end


hooksecurefunc("GameTooltip_SetDefaultAnchor",function(tooltip, parent)		
	tooltip:SetOwner(parent, "ANCHOR_NONE");
	tooltip:SetPoint(SemiTipAnchorPos, "UIParent", SemiTipAnchorPos, SemiTipX, SemiTipY);
	tooltip.default = 1;
end);